package processor;

/**
 * An action some kind of command that can be send to the {@link Algorithm} from the {@link ProcessController}.
 * {@code FORWARD} tells the {@link Algorithm} to perform one more step in the layout process.
 * {@code BACKWARD} tells the {@link Algorithm} to undo the last step in the layout process.
 * 
 * @author kolja
 *
 */
public enum Action {
    /**
     *  step into in forwards direction
     */
    FORWARD,
    /**
     *  step over in forwards direction
     */
    FORWARD_OVER,
    /**
     *  step out in forwards direction
     */
    FORWARD_OUT,
    /**
     *  step into in backwards direction
     */
    BACKWARD,
    /**
     *  step over in backwards direction
     */
    BACKWARD_OVER,
    /**
     *  step out in backwards direction
     */
    BACKWARD_OUT
}
