package test;

import javax.swing.JFrame;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;

import bk.BKNodePlacement;
import graph.LayeredGraphNode;
import graph.RandomGraphGenerator;
import graph.io.Reader;
import lib.SimpleNodePlacement;
import lib.SweepCrossingMinimizer;
import processor.PseudoCodeNode;
import processor.PseudoCodeProcessor;

@SuppressWarnings("unused")
class TestProcessor {
    
    public static void main(String[] args) throws InterruptedException {

        RandomGraphGenerator r = new RandomGraphGenerator( 0.2, 0.8, 3, 5, 2, 5, 3 );
        LayeredGraphNode graph = r.createRandomNode( null, 0, true );
        SweepCrossingMinimizer cminzer = new SweepCrossingMinimizer();
        for( int i = 0; i < 10; i++ )
          cminzer.minimizeCrossings( graph );
        SimpleNodePlacement.placeNodes( graph );
    
        //Reader r = new Reader( "papergraph.json" );
        //LayeredGraphNode graph = r.readInputGraph();
        //SimpleNodePlacement.placeNodes( graph );

        BKNodePlacement algorithm = new BKNodePlacement();
        JTree pseudoTree = new JTree();
        PseudoCodeNode tree = algorithm.createPseudocodeTree( pseudoTree );
        pseudoTree.setModel( new DefaultTreeModel( tree ) );
        JFrame frame = new JFrame( "NodeShuffler" );
        PseudoCodeProcessor processor = new StepInProcessor( tree, graph, frame );
        tree.setController( processor.getController() );
        processor.start();
        processor.join();
        processor = new StepInProcessor( tree, graph, frame );
        tree.setController( processor.getController() );
        for( int i = pseudoTree.getRowCount() - 1; i > 0; i-- )
            pseudoTree.collapseRow( i );
        processor.getController().setStepOption( 1 );
        processor.start();
        processor.join();
        processor = new StepOverProcessor( tree, graph, frame );
        tree.setController( processor.getController() );
        processor.start();
        processor.join();
        processor = new StepOverProcessor( tree, graph, frame );
        tree.setController( processor.getController() );
        for( int i = pseudoTree.getRowCount() - 1; i > 0; i-- )
            pseudoTree.collapseRow( i );
        processor.getController().setStepOption( 1 );
        processor.start();
        processor.join();
        processor = new RandomProcessor( tree, graph, frame );
        tree.setController( processor.getController() );
        processor.start();
        processor.join();
        System.out.println( "Tests Finished." );
    }
}
